workflow:
 rules:
  - if: $CI_COMMIT_TAG =~ /^v/
    when: always
  - if: $CI_COMMIT_TAG =~ /^do/
    when: always
  - if: $CI_COMMIT_TAG =~ /^fix/
    when: always
  - if: $CI_COMMIT_TAG =~ /^tmp/
    when: always
  - if: $CI_COMMIT_TAG =~ /^dev/
    when: always

stages:
 - build

docker-build:
 stage: build
 image: docker:20.10.1
 variables:
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: "/certs"
 services:
  - docker:20.10.1-dind
 before_script:
  - apk --update add docker-compose
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
 script:
  # We don't want to build images with existing tags, lest we overwrite old images in image registry.
  - docker pull $CI_REGISTRY_IMAGE/app:hot || true
  - docker-compose build
  - docker tag app:latest $CI_REGISTRY_IMAGE/app:$CI_COMMIT_TAG
  - docker tag app:latest $CI_REGISTRY_IMAGE/app:hot
  - docker images
  - docker push $CI_REGISTRY_IMAGE/app:$CI_COMMIT_TAG
  - docker push $CI_REGISTRY_IMAGE/app:hot
